/*================================================================================================================*/
// ANALYZED BY DANY:
// DECEMBER 2006:
// SONORA LARGE:
// JUNE 2004:
/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// **************************************** CHOOSE THE NATIVES TRIBES: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int subCiv0=-1;
      int subCiv1=-1;
      int subCiv2=-1;
      int subCiv3=-1;
	  int subCiv4=-1;
      int subCiv5=-1;
	  
	  if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
      if (subCiv0 >= 0)
         rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
      if (subCiv1 >= 0)
         rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Iroquois");
      if (subCiv2 >= 0)
         rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
      if (subCiv3 >= 0)
         rmSetSubCiv(3, "Iroquois");
		 
		 subCiv4=rmGetCivID("Iroquois");
      if (subCiv4 >= 0)
         rmSetSubCiv(4, "Iroquois");

		subCiv5=rmGetCivID("Iroquois");
      if (subCiv5 >= 0)
         rmSetSubCiv(5, "Iroquois");
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE ********************************************** //
/*================================================================================================================*/
	  int playerTiles = 25000;
	
	//  if (cNumberNonGaiaPlayers >4)
		  //playerTiles = 16000;
	  //if (cNumberNonGaiaPlayers >6)
		 // playerTiles = 12000;		
	  /*
      if(cMapSize == 1)
   {
      playerTiles = 18000;
      rmEchoInfo("Large map");
   }
      */

	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	  rmEchoInfo("Map size="+size+"m x "+size+"m");
	  rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** PICKS THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
	  // SET MAP ELEVATION PARAMETERS:
	  // rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	  //rmSetMapElevationParameters(cElevTurbulence, 0.02, 4, 0.7, 8.0);
	  //rmSetMapElevationParameters(cElevTurbulence, 0.02, 3, 0.5, 8.0);
	  //rmSetMapElevationHeightBlend(1);

	  // PICKS A DEFAULT WATER HEIGHT:
	  rmSetSeaLevel(4.5);

      // PICKS DEFAULT WATER:
	  rmSetSeaType("Yukon River");
	  
	  // PICKS DEFAULT TERRAIN:
	  rmSetBaseTerrainMix("yukon snow");
	  
	  // TERRAIN INITIALIZE:
	  rmTerrainInitialize("yukon\ground1_yuk", 6);
	  
	  // SET MAP TYPE:
	  rmSetMapType("yukon");
	  rmSetMapType("snow");
	  rmSetMapType("land");
	         
      // SET LIGHTING:	   
	  rmSetLightingSet("yukon");
	  
	  // MAKE IT SNOW:
      rmSetGlobalSnow( 0.7 );
	
	  // CORNER CONSTRAINT:
	  rmSetWorldCircleConstraint(false);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ********************************************* DEFINE THE CLASSES: ******************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int classPlayer=rmDefineClass("player");
	  rmDefineClass("startingUnit");
	  int canyon=rmDefineClass("canyon");
	  rmDefineClass("classForest");
	  rmDefineClass("classSocket");
	  rmDefineClass("natives");
	  rmDefineClass("nuggets");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      // MAP EDGE AVOIDANCE:
	  int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(15), rmZTilesToFraction(15), 1.0-rmXTilesToFraction(15), 1.0-rmZTilesToFraction(15), 0.01);
   	  //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(15), rmZTilesToFraction(15), 1.0-rmXTilesToFraction(15), 1.0-rmZTilesToFraction(15), 0.01);
        
      // Cardinal Directions
      int North1ward=rmCreatePieConstraint("north1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(0), rmDegreesToRadians(15));
      int North2ward=rmCreatePieConstraint("north2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(16), rmDegreesToRadians(30));
      int North5ward=rmCreatePieConstraint("north5MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(60), rmDegreesToRadians(74));
      int North6ward=rmCreatePieConstraint("north6MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(75), rmDegreesToRadians(90));
      
	  int South1ward=rmCreatePieConstraint("south1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(255), rmDegreesToRadians(270));
      int South2ward=rmCreatePieConstraint("south2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(240), rmDegreesToRadians(254));
      int South5ward=rmCreatePieConstraint("south5MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(196), rmDegreesToRadians(210));
      int South6ward=rmCreatePieConstraint("south6MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(180), rmDegreesToRadians(195));
      
	  int East1ward=rmCreatePieConstraint("east1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(165), rmDegreesToRadians(180));
      int East2ward=rmCreatePieConstraint("east2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(150), rmDegreesToRadians(164));
      int East5ward=rmCreatePieConstraint("east5MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(106), rmDegreesToRadians(120));
      int East6ward=rmCreatePieConstraint("east6MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(90), rmDegreesToRadians(105));
     
	  
	  int West1ward=rmCreatePieConstraint("west1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(270), rmDegreesToRadians(285));
      int West2ward=rmCreatePieConstraint("west2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(284), rmDegreesToRadians(300));
      int West5ward=rmCreatePieConstraint("west5MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(330), rmDegreesToRadians(344));
      int West6ward=rmCreatePieConstraint("west6MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(345), rmDegreesToRadians(360));
  
	  // CANYON AVOIDANCE:
	  //int canyonConstraint=rmCreateClassDistanceConstraint("canyons start away from each other", canyon, 5.0);
	  
	  // PLAYER AVOIDANCE:
	  int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
	  
	  // FORESTS AVOIDANCE:
      int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
      int avoidForest=rmCreateClassDistanceConstraint("stuffs avoids forest", rmClassID("classForest"), 10.0);
      
	  // CARIBOU AVOIDANCE:
	  int avoidCaribou=rmCreateTypeDistanceConstraint("stuffs avoids caribou", "Caribou", 8.0);
	  int caribouAvoidCaribou=rmCreateTypeDistanceConstraint("caribou avoids caribou", "Caribou", 40.0);
	  
	  // COW AVOIDANCE:
	  int avoidCow=rmCreateTypeDistanceConstraint("stuffs avoids cow", "cow", 10.0);
	  int cowAvoidCow=rmCreateTypeDistanceConstraint("cow avoids cow", "cow", 40.0);
	  
	  // SHEEP AVOIDANCE:
	  int avoidSheep=rmCreateTypeDistanceConstraint("stuffs avoids sheep", "sheep", 10.0);
	  int sheepAvoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 40.0);
	  
	  // TREES AVOIDANCE:
	  int avoidTree=rmCreateTypeDistanceConstraint("stuffs avoids Tree", "TreeYukon", 5.0);
	  int treeAvoidTree=rmCreateTypeDistanceConstraint("Tree avoids Tree", "TreeYukon", 10.0);
		  
	  // BERRIES AVOIDANCE:
	  int avoidFruits=rmCreateTypeDistanceConstraint("stuffs avoids fruits", "berrybush", 8.0);
	  int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 40.0);
	  
	  // COIN AVOIDANCE:
	  int avoidCoin=rmCreateTypeDistanceConstraint("stuffs avoid coin", "minegold", 8.0);	
	  int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoid coin", "minegold", 40.0);

      // NUGGETS AVOIDANCE:
	  int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nugget", rmClassID("nuggets"), 10.0);
	  int nuggetAvoidNugget=rmCreateClassDistanceConstraint("nugget avoids nugget", rmClassID("nuggets"), 30.0);
	  
	  // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
	  
	  // UNIT AVOIDANCE:
	  int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
	  
	  // NATIVES AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
      int avoidCloseNatives=rmCreateClassDistanceConstraint("Gift avoids natives", rmClassID("natives"), 1.0);
 
	  
   	  // VP AVOIDANCE:
      int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 4.0);
      
	  // SOCKET AVOIDANCE:
	  int avoidSocket=rmCreateClassDistanceConstraint("stuffs avoid socket", rmClassID("classSocket"), 8.0);
	  
	  // IMPASSABLE LAND AVOIDANCE:
	  int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	  int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 4.0);
	
	  // RESOURCE AVOIDANCE:
	  int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************* DEFINE THE STARTING TCID AND STARTING UNITS: ********************************* //
/*================================================================================================================*/
	  // DEFINE THE STARTING TCID:
	  int TCID = rmCreateObjectDef("player TC");
		  if (rmGetNomadStart())
		  {
			  rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
		  }
		  else
		  {
              rmAddObjectDefItem(TCID, "townCenter", 1, 0);
		  }
	  rmSetObjectDefMinDistance(TCID, 0.0);
	  rmSetObjectDefMaxDistance(TCID, 10.0);
	  rmAddObjectDefConstraint(TCID, avoidTradeRoute);
	  rmAddObjectDefToClass(TCID, rmClassID("player"));
	  rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));

	  // DEFINE THE STARTING UNITS:
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	  rmSetObjectDefMinDistance(startingUnits, 8.0);
	  rmSetObjectDefMaxDistance(startingUnits, 12.0);
	  rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(startingUnits, avoidStartingUnits);
/*================================================================================================================*/
// *************************************** DEFINE THE STARTING RESOURCES: *************************************** //
/*================================================================================================================*/
	  // DEFINE THE PLAYER SILVER:
	  int playerSilverID = rmCreateObjectDef("player silver");
	  rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	  rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	  rmSetObjectDefMinDistance(playerSilverID, 20.0);
	  rmSetObjectDefMaxDistance(playerSilverID, 25.0);
	  //rmAddObjectDefConstraint(playerSilverID, avoidAll);
	  rmAddObjectDefConstraint(playerSilverID, edgeConstraint);
	  rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
	  rmAddObjectDefConstraint(playerSilverID, avoidStartingUnits);

	  // DEFINE THE STARTING TREES:
	  int StartAreaTreeID=rmCreateObjectDef("starting trees");
	  //rmAddObjectDefItem(StartAreaTreeID, "TreeYukon", rmRandInt(7,10), 12.0);
	  rmAddObjectDefItem(StartAreaTreeID, "TreeChristmas", rmRandInt(7,12), 12.0);
	  //rmAddObjectDefItem(StartAreaTreeID, "UnderbrushDesert", rmRandInt(4,6), 4.0);
	  rmSetObjectDefMinDistance(StartAreaTreeID, 8);
	  rmSetObjectDefMaxDistance(StartAreaTreeID, 15);
	  rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidImpassableLand);
	  rmAddObjectDefConstraint(StartAreaTreeID, edgeConstraint);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidSilver);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnits);
	  //rmAddObjectDefConstraint(StartAreaTreeID, avoidResource);

	  // DEFINE THE STARTING TURKEYS:
	  int StartTurkeyID=rmCreateObjectDef("starting berries");
	  rmAddObjectDefItem(StartTurkeyID, "berrybush", 4, 6.0);
	  //rmSetObjectDefCreateHerd(StartTurkeyID, true);
	  rmSetObjectDefMinDistance(StartTurkeyID, 10);
	  rmSetObjectDefMaxDistance(StartTurkeyID, 18);
	  rmAddObjectDefToClass(StartTurkeyID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(StartTurkeyID, avoidImpassableLand);
	  rmAddObjectDefConstraint(StartTurkeyID, avoidTradeRoute);
	  rmAddObjectDefConstraint(StartTurkeyID, edgeConstraint);
	  rmAddObjectDefConstraint(StartTurkeyID, avoidStartingUnits);
	  rmAddObjectDefConstraint(StartTurkeyID, avoidResource);
	  
	  int playerNuggetID=rmCreateObjectDef("player nugget");
	  rmAddObjectDefItem(playerNuggetID, "GiftCoin", 1, 0.0);
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	  rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
      rmSetObjectDefMinDistance(playerNuggetID, 30.0);
      rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	  rmSetNuggetDifficulty(1, 1);
	  rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnits);
	  rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
	  rmAddObjectDefConstraint(playerNuggetID, avoidSocket);
	  rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	  rmAddObjectDefConstraint(playerNuggetID, edgeConstraint);	
	  rmAddObjectDefConstraint(playerNuggetID, avoidResource);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
	int canyonConstraint=rmCreateClassDistanceConstraint("canyons start away from each other", canyon, 15.0);

	int failCount=0;
	int numTries=cNumberNonGaiaPlayers*15;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************ DEFINE THE TRADE ROUTE AND SOCKETS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/	
// ********************************** DEFINE AND PLACE THE 2 TRADE ROUTES: ************************************** //
/*================================================================================================================*/ 
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.95);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.05, 0.5);
	  //rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.2, 0.3, 10, 4);

      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 2:
	  int tradeRoute2ID = rmCreateTradeRoute();
      socketID=rmCreateObjectDef("sockets to dock Trade Posts north");
      rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.95, 0.5);
	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.5, 0.05);
	  //rmAddRandomTradeRouteWaypoints(tradeRoute2ID, 0.2, 0.7, 10, 4);

      placedTradeRoute = rmBuildTradeRoute(tradeRoute2ID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 2:
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ******************************************** CREATE A CENTER AREA: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************** PLACE THE PLAYERS LOCATIONS: ****************************************** //
/*================================================================================================================*/
	if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.80,0.80);
		//rmPlacePlayer(3,0.80,0.20);
		//rmPlacePlayer(5,0.50,0.90);
		//rmPlacePlayer(7,0.10,0.50);
		
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.20,0.20);
		//rmPlacePlayer(4,0.20,0.80);
		//rmPlacePlayer(6,0.90,0.50);
		//rmPlacePlayer(8,0.50,0.10);
	}
/*	else
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
	}*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ***************************************** SET UP PLAYER AREAS: *********************************************** //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(100);
      for(i=1; <cNumberPlayers)
   {
      // Create the area.
      int id=rmCreateArea("Player"+i);
      // Assign to the player.
      rmSetPlayerArea(i, id);
      // Set the size.
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      //rmAddAreaConstraint(id, playerConstraint); 
      //rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmSetAreaLocPlayer(id, i);
	  rmSetAreaTerrainType(id, "yukon\ground1_yuk");
      rmSetAreaWarnFailure(id, false);
   }
	  // Build the areas.
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ***************************************** UBER MINE AT CENTER ************************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois1VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.6, 0.8);
	} 

	if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois2VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.8, 0.6);
	} 

	if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois3VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois3VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.2, 0.4);
	}

	if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois4VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois4VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.4, 0.2);
	} 
	
	    if (subCiv4 == rmGetCivID("iroquois"))
	{  
		int iroquois5VillageID = -1;
		iroquois5VillageID = rmCreateGrouping("iroquois village 5", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois5VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois5VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois5VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois5VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois5VillageID, avoidNatives);
		rmAddGroupingConstraint(iroquois5VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(iroquois5VillageID, 0, 0.2, 0.8);
	} 

	    if (subCiv5 == rmGetCivID("iroquois"))
	{  
		int iroquois6VillageID = -1;
		iroquois6VillageID = rmCreateGrouping("iroquois village 6", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois6VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois6VillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquois6VillageID, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(iroquois6VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois6VillageID, avoidNatives);
		rmAddGroupingConstraint(iroquois6VillageID, avoidSocket);
		rmPlaceGroupingAtLoc(iroquois6VillageID, 0, 0.8, 0.2);
	} 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE CLIFF EMBELLISHMENTS: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE SMALL CLIFFS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE MOUNTAIN 1: *************************************** //
/*================================================================================================================*/
	    //int numTries = 1;
		numTries = 1;
	    for(i=0; <numTries)
	{
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa 1"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));  
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, "rocky mountain2");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	
		//rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(smallMesaID, 2, 0.4, 0.1, 1.0, 0);
		//rmSetAreaCliffHeight(smallMesaID, rmRandInt(6, 8), 1.0, 1.0);  
		rmSetAreaCliffHeight(smallMesaID, -6, 1.0, 1.0);  
		rmSetAreaCoherence(smallMesaID, 0.88);
		rmSetAreaLocation(smallMesaID, 0.6, 0.8); 
		
		rmBuildArea(smallMesaID);
	}
	    // Special AREA CONSTRAINT and use it to make resources avoid the big mtn in center:
		int smallMesaConstraint = rmCreateAreaDistanceConstraint("avoid Small Mesa", smallMesaID, 4.0);	 
/*================================================================================================================*/
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE MOUNTAIN 2: *************************************** //
/*================================================================================================================*/
	    //numTries = 1;
		for(i=0; <numTries)
	{
		int smallCliff2Height=rmRandInt(0,10);
		int smallMesa2ID=rmCreateArea("small mesa 2"+i);
		rmSetAreaSize(smallMesa2ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));  
		rmSetAreaWarnFailure(smallMesa2ID, false);
		rmSetAreaCliffType(smallMesa2ID, "rocky mountain2");
		rmAddAreaToClass(smallMesa2ID, rmClassID("canyon"));	
		//rmSetAreaCliffEdge(smallMesa2ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(smallMesa2ID, 2, 0.4, 0.1, 1.0, 0);
		//rmSetAreaCliffHeight(smallMesa2ID, rmRandInt(6, 8), 1.0, 1.0); 
        rmSetAreaCliffHeight(smallMesa2ID, -6, 1.0, 1.0); 		
		rmSetAreaCoherence(smallMesa2ID, 0.88);
		rmSetAreaLocation(smallMesa2ID, 0.8, 0.6); 
		
		rmBuildArea(smallMesa2ID);
	}
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE MOUNTAIN 3: *************************************** //
/*================================================================================================================*/
	    //numTries = 1;
		for(i=0; <numTries)
	{
		int smallCliff3Height=rmRandInt(0,10);
		int smallMesa3ID=rmCreateArea("small mesa 3"+i);
		rmSetAreaSize(smallMesa3ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));  
		rmSetAreaWarnFailure(smallMesa3ID, false);
		rmSetAreaCliffType(smallMesa3ID, "rocky mountain2");
		rmAddAreaToClass(smallMesa3ID, rmClassID("canyon"));	
		//rmSetAreaCliffEdge(smallMesa3ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(smallMesa3ID, 2, 0.4, 0.1, 1.0, 0);
		//rmSetAreaCliffHeight(smallMesa3ID, rmRandInt(6, 8), 1.0, 1.0); 
        rmSetAreaCliffHeight(smallMesa3ID, -6, 1.0, 1.0);  		
		rmSetAreaCoherence(smallMesa3ID, 0.88);
		rmSetAreaLocation(smallMesa3ID, 0.2, 0.4); 
		
		rmBuildArea(smallMesa3ID);
	}
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE MOUNTAIN 4: *************************************** //
/*================================================================================================================*/
	    //numTries = 1;
		for(i=0; <numTries)
	{
		int smallCliff4Height=rmRandInt(0,10);
		int smallMesa4ID=rmCreateArea("small mesa 4"+i);
		rmSetAreaSize(smallMesa4ID, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));  
		rmSetAreaWarnFailure(smallMesa4ID, false);
		rmSetAreaCliffType(smallMesa4ID, "rocky mountain2");
		rmAddAreaToClass(smallMesa4ID, rmClassID("canyon"));	
		//rmSetAreaCliffEdge(smallMesa4ID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffEdge(smallMesa4ID, 2, 0.4, 0.1, 1.0, 0);
		//rmSetAreaCliffHeight(smallMesa4ID, rmRandInt(6, 8), 1.0, 1.0);
        rmSetAreaCliffHeight(smallMesa4ID, -6, 1.0, 1.0);		
		rmSetAreaCoherence(smallMesa4ID, 0.88);
		rmSetAreaLocation(smallMesa4ID, 0.4, 0.2); 
		
		rmBuildArea(smallMesa4ID);
	}	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ********************* PLACING THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************* //
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
		// TEST OF MARCIN'S STARTING UNITS STUFF:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartTurkeyID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

   	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE FORESTS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE FORESTS NUMBER 1: ************************************ //
/*================================================================================================================*/
      int forestTreeID = 0;
      //int numTries=6*cNumberNonGaiaPlayers;
      failCount=0;

      for (i=0; <numTries)
   {   
      int forest=rmCreateArea("forest "+i);
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(4500), rmAreaTilesToFraction(4500));
      //rmSetAreaForestType(forest, "yukon snow forest");
	  rmSetAreaForestType(forest, "Christmas Forest");
	  //rmSetAreaForestDensity(forest, 1.0);
	  rmSetAreaForestDensity(forest, 0.4);
	  //rmSetAreaBaseHeight(forest, 10);
	  //rmSetAreaForestClumpiness(forest, 0.4);
      //rmSetAreaForestUnderbrush(forest, 0.0);
	  rmSetAreaForestClumpiness(forest, 0.5);
      rmSetAreaForestUnderbrush(forest, 1.0);
      rmSetAreaCoherence(forest, 0.4);
      rmSetAreaSmoothDistance(forest, 10);
      rmAddAreaToClass(forest, rmClassID("classForest"));
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidAll);
      rmAddAreaConstraint(forest, avoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);
	  rmAddAreaConstraint(forest, avoidFruits);
	  rmAddAreaConstraint(forest, avoidCaribou);
	  rmAddAreaConstraint(forest, avoidSocket);
	  rmAddAreaConstraint(forest, avoidCoin);
	  rmAddAreaConstraint(forest, canyonConstraint);
	  rmAddAreaConstraint(forest, smallMesaConstraint);
	  rmSetAreaLocation(forest, 0.5, 0.5); 
	  if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
         break;
      }
         else
         failCount=0; 
   } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE COIN RESOURCES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    // Scattered MINES
	int goldID = rmCreateObjectDef("random gold 1");
	rmAddObjectDefItem(goldID, "minegold", 1, 9);
	rmAddObjectDefItem(goldID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(goldID, 0.0);
	rmSetObjectDefMaxDistance(goldID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(goldID, edgeConstraint);
	rmAddObjectDefConstraint(goldID, North2ward);
	rmAddObjectDefConstraint(goldID, avoidCaribou);
	rmAddObjectDefConstraint(goldID, avoidFruits);
	rmAddObjectDefConstraint(goldID, avoidAll);
	rmAddObjectDefConstraint(goldID, avoidTradeRoute);
	rmAddObjectDefConstraint(goldID, avoidSocket);
	rmAddObjectDefConstraint(goldID, avoidCoin);
	rmAddObjectDefConstraint(goldID, avoidForest);
	rmAddObjectDefConstraint(goldID, coinAvoidCoin);
    rmAddObjectDefConstraint(goldID, avoidImpassableLand);
	rmAddObjectDefConstraint(goldID, canyonConstraint);
	rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.5);
	
	// Scattered MINES
	int gold2ID = rmCreateObjectDef("random gold 2");
	rmAddObjectDefItem(gold2ID, "minegold", 1, 9);
	rmAddObjectDefItem(gold2ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold2ID, 0.0);
	rmSetObjectDefMaxDistance(gold2ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(gold2ID, edgeConstraint);
	rmAddObjectDefConstraint(gold2ID, South2ward);
	rmAddObjectDefConstraint(gold2ID, avoidAll);
	rmAddObjectDefConstraint(gold2ID, avoidCaribou);
	rmAddObjectDefConstraint(gold2ID, avoidFruits);
	rmAddObjectDefConstraint(gold2ID, avoidForest);
	rmAddObjectDefConstraint(gold2ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold2ID, avoidSocket);
	rmAddObjectDefConstraint(gold2ID, avoidCoin);
	rmAddObjectDefConstraint(gold2ID, coinAvoidCoin);
    rmAddObjectDefConstraint(gold2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(gold2ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.5);
	
	// Scattered MINES
	int gold3ID = rmCreateObjectDef("random gold 3");
	rmAddObjectDefItem(gold3ID, "minegold", 1, 9);
	rmAddObjectDefItem(gold3ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold3ID, 0.0);
	rmSetObjectDefMaxDistance(gold3ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(gold3ID, edgeConstraint);
	rmAddObjectDefConstraint(gold3ID, East2ward);
	rmAddObjectDefConstraint(gold3ID, avoidAll);
	rmAddObjectDefConstraint(gold3ID, avoidCaribou);
	rmAddObjectDefConstraint(gold3ID, avoidFruits);
	rmAddObjectDefConstraint(gold3ID, avoidForest);
	rmAddObjectDefConstraint(gold3ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold3ID, avoidSocket);
	rmAddObjectDefConstraint(gold3ID, avoidCoin);
	rmAddObjectDefConstraint(gold3ID, coinAvoidCoin);
    rmAddObjectDefConstraint(gold3ID, avoidImpassableLand);
	rmAddObjectDefConstraint(gold3ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold3ID, 0, 0.5, 0.5);
	
	// Scattered MINES
	int gold4ID = rmCreateObjectDef("random gold 4");
	rmAddObjectDefItem(gold4ID, "minegold", 1, 9);
	rmAddObjectDefItem(gold4ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold4ID, 0.0);
	rmSetObjectDefMaxDistance(gold4ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(gold4ID, edgeConstraint);
	rmAddObjectDefConstraint(gold4ID, West2ward);
	rmAddObjectDefConstraint(gold4ID, avoidAll);
	rmAddObjectDefConstraint(gold4ID, avoidCaribou);
	rmAddObjectDefConstraint(gold4ID, avoidFruits);
	rmAddObjectDefConstraint(gold4ID, avoidForest);
	rmAddObjectDefConstraint(gold4ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold4ID, avoidSocket);
	rmAddObjectDefConstraint(gold4ID, avoidCoin);
	rmAddObjectDefConstraint(gold4ID, coinAvoidCoin);
    rmAddObjectDefConstraint(gold4ID, avoidImpassableLand);
	rmAddObjectDefConstraint(gold4ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold4ID, 0, 0.5, 0.5);
	
	// Scattered MINES
	int gold5ID = rmCreateObjectDef("random gold 5");
	rmAddObjectDefItem(gold5ID, "minegold", 1, 9);
	rmAddObjectDefItem(gold5ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold5ID, 0.0);
	rmSetObjectDefMaxDistance(gold5ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(gold5ID, edgeConstraint);
	rmAddObjectDefConstraint(gold5ID, North5ward);
	rmAddObjectDefConstraint(gold5ID, avoidAll);
	rmAddObjectDefConstraint(gold5ID, avoidCaribou);
	rmAddObjectDefConstraint(gold5ID, avoidFruits);
	rmAddObjectDefConstraint(gold5ID, avoidForest);
	rmAddObjectDefConstraint(gold5ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold5ID, avoidSocket);
	rmAddObjectDefConstraint(gold5ID, avoidCoin);
	rmAddObjectDefConstraint(gold5ID, coinAvoidCoin);
    rmAddObjectDefConstraint(gold5ID, avoidImpassableLand);
	rmAddObjectDefConstraint(gold5ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold5ID, 0, 0.5, 0.5);
	
	// Scattered MINES
	int gold6ID = rmCreateObjectDef("random gold 6");
	rmAddObjectDefItem(gold6ID, "minegold", 1, 9);
	rmAddObjectDefItem(gold6ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold6ID, 0.0);
	rmSetObjectDefMaxDistance(gold6ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(gold6ID, edgeConstraint);
	rmAddObjectDefConstraint(gold6ID, South5ward);
	rmAddObjectDefConstraint(gold6ID, avoidAll);
	rmAddObjectDefConstraint(gold6ID, avoidCaribou);
	rmAddObjectDefConstraint(gold6ID, avoidFruits);
	rmAddObjectDefConstraint(gold6ID, avoidForest);
	rmAddObjectDefConstraint(gold6ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold6ID, avoidSocket);
	rmAddObjectDefConstraint(gold6ID, avoidCoin);
	rmAddObjectDefConstraint(gold6ID, coinAvoidCoin);
    rmAddObjectDefConstraint(gold6ID, avoidImpassableLand);
	rmAddObjectDefConstraint(gold6ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold6ID, 0, 0.5, 0.5);
	
	// Scattered MINES
	int gold7ID = rmCreateObjectDef("random gold 7");
	rmAddObjectDefItem(gold7ID, "minegold", 1, 9);
	rmAddObjectDefItem(gold7ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold7ID, 0.0);
	rmSetObjectDefMaxDistance(gold7ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(gold7ID, edgeConstraint);
	rmAddObjectDefConstraint(gold7ID, East5ward);
	rmAddObjectDefConstraint(gold7ID, avoidAll);
	rmAddObjectDefConstraint(gold7ID, avoidCaribou);
	rmAddObjectDefConstraint(gold7ID, avoidFruits);
	rmAddObjectDefConstraint(gold7ID, avoidForest);
	rmAddObjectDefConstraint(gold7ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold7ID, avoidSocket);
	rmAddObjectDefConstraint(gold7ID, avoidCoin);
	rmAddObjectDefConstraint(gold7ID, coinAvoidCoin);
    rmAddObjectDefConstraint(gold7ID, avoidImpassableLand);
	rmAddObjectDefConstraint(gold7ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold7ID, 0, 0.5, 0.5);
	
	// Scattered MINES
	int gold8ID = rmCreateObjectDef("random gold 8");
	rmAddObjectDefItem(gold8ID, "minegold", 1, 9);
	rmAddObjectDefItem(gold8ID, "GiftCoin", 1, 9);
	rmSetObjectDefMinDistance(gold8ID, 0.0);
	rmSetObjectDefMaxDistance(gold8ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(gold8ID, edgeConstraint);
	rmAddObjectDefConstraint(gold8ID, West5ward);
	rmAddObjectDefConstraint(gold8ID, avoidAll);
	rmAddObjectDefConstraint(gold8ID, avoidCaribou);
	rmAddObjectDefConstraint(gold8ID, avoidFruits);
	rmAddObjectDefConstraint(gold8ID, avoidForest);
	rmAddObjectDefConstraint(gold8ID, avoidTradeRoute);
	rmAddObjectDefConstraint(gold8ID, avoidSocket);
	rmAddObjectDefConstraint(gold8ID, avoidCoin);
	rmAddObjectDefConstraint(gold8ID, coinAvoidCoin);
    rmAddObjectDefConstraint(gold8ID, avoidImpassableLand);
	rmAddObjectDefConstraint(gold8ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(gold8ID, 0, 0.5, 0.5);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE RANDOM TREES: ************************************* //
/*================================================================================================================*/	
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.86);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TREASURES *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int nugget1ID= rmCreateObjectDef("nugget easy 1"); 
		rmAddObjectDefItem(nugget1ID, "GiftCoin", 1, 0.0);
		rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget1ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget1ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget1ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget1ID, avoidSocket);
		rmAddObjectDefConstraint(nugget1ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget1ID, avoidCoin);
		rmAddObjectDefConstraint(nugget1ID, avoidForest);
		rmAddObjectDefConstraint(nugget1ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget1ID, North1ward);
		rmAddObjectDefConstraint(nugget1ID, avoidFruits);
		rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmAddObjectDefConstraint(nugget1ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget1ID, avoidNatives);
		rmAddObjectDefConstraint(nugget1ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.5, 0.5);
		
		int nugget2ID= rmCreateObjectDef("nugget easy 2"); 
		rmAddObjectDefItem(nugget2ID, "GiftFood", 1, 0.0);
		rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget2ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget2ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget2ID, avoidSocket);
		rmAddObjectDefConstraint(nugget2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget2ID, avoidCoin);
		rmAddObjectDefConstraint(nugget2ID, avoidForest);
		rmAddObjectDefConstraint(nugget2ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget2ID, West1ward);
		rmAddObjectDefConstraint(nugget2ID, avoidFruits);
		rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmAddObjectDefConstraint(nugget2ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget2ID, avoidNatives);
		rmAddObjectDefConstraint(nugget2ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5);
		
		int nugget3ID= rmCreateObjectDef("nugget easy 3"); 
		rmAddObjectDefItem(nugget3ID, "GiftWood", 1, 0.0);
		rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget3ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget3ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget3ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget3ID, avoidSocket);
		rmAddObjectDefConstraint(nugget3ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget3ID, avoidCoin);
		rmAddObjectDefConstraint(nugget3ID, avoidForest);
		rmAddObjectDefConstraint(nugget3ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget3ID, East1ward);
		rmAddObjectDefConstraint(nugget3ID, avoidFruits);
		rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmAddObjectDefConstraint(nugget3ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget3ID, avoidNatives);
		rmAddObjectDefConstraint(nugget3ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.5, 0.5);
		
		int nugget4ID= rmCreateObjectDef("nugget easy 4"); 
		rmAddObjectDefItem(nugget4ID, "GiftCoin", 1, 0.0);
		rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget4ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget4ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget4ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget4ID, avoidSocket);
		rmAddObjectDefConstraint(nugget4ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget4ID, avoidCoin);
		rmAddObjectDefConstraint(nugget4ID, avoidForest);
		rmAddObjectDefConstraint(nugget4ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget4ID, South1ward);
		rmAddObjectDefConstraint(nugget4ID, avoidFruits);
		rmAddObjectDefConstraint(nugget4ID, avoidNugget);
		rmAddObjectDefConstraint(nugget4ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget4ID, avoidNatives);
		rmAddObjectDefConstraint(nugget4ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.5, 0.5);
		
		int nugget5ID= rmCreateObjectDef("nugget easy 5"); 
		rmAddObjectDefItem(nugget5ID, "GiftFood", 1, 0.0);
		rmSetObjectDefMinDistance(nugget5ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget5ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget5ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget5ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget5ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget5ID, avoidSocket);
		rmAddObjectDefConstraint(nugget5ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget5ID, avoidCoin);
		rmAddObjectDefConstraint(nugget5ID, avoidForest);
		rmAddObjectDefConstraint(nugget5ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget5ID, East6ward);
		rmAddObjectDefConstraint(nugget5ID, avoidFruits);
		rmAddObjectDefConstraint(nugget5ID, avoidNugget);
		rmAddObjectDefConstraint(nugget5ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget5ID, avoidNatives);
		rmAddObjectDefConstraint(nugget5ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget5ID, 0, 0.5, 0.5);
		
		int nugget6ID= rmCreateObjectDef("nugget easy 6"); 
		rmAddObjectDefItem(nugget6ID, "GiftWood", 1, 0.0);
		rmSetObjectDefMinDistance(nugget6ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget6ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget6ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget6ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget6ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget6ID, avoidSocket);
		rmAddObjectDefConstraint(nugget6ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget6ID, avoidCoin);
		rmAddObjectDefConstraint(nugget6ID, avoidForest);
		rmAddObjectDefConstraint(nugget6ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget6ID, West6ward);
		rmAddObjectDefConstraint(nugget6ID, avoidFruits);
		rmAddObjectDefConstraint(nugget6ID, avoidNugget);
		rmAddObjectDefConstraint(nugget6ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget6ID, avoidNatives);
		rmAddObjectDefConstraint(nugget6ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget6ID, 0, 0.5, 0.5);
		
		int nugget7ID= rmCreateObjectDef("nugget easy 7"); 
		rmAddObjectDefItem(nugget7ID, "GiftCoin", 1, 0.0);
		rmSetObjectDefMinDistance(nugget7ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget7ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget7ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget7ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget7ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget7ID, avoidSocket);
		rmAddObjectDefConstraint(nugget7ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget7ID, avoidCoin);
		rmAddObjectDefConstraint(nugget7ID, avoidForest);
		rmAddObjectDefConstraint(nugget7ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget7ID, North6ward);
		rmAddObjectDefConstraint(nugget7ID, avoidFruits);
		rmAddObjectDefConstraint(nugget7ID, avoidNugget);
		rmAddObjectDefConstraint(nugget7ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget7ID, avoidNatives);
		rmAddObjectDefConstraint(nugget7ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget7ID, 0, 0.5, 0.5);
		
		int nugget8ID= rmCreateObjectDef("nugget easy 8"); 
		rmAddObjectDefItem(nugget8ID, "GiftFood", 1, 0.0);
		rmSetObjectDefMinDistance(nugget8ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget8ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget8ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget8ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget8ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget8ID, avoidSocket);
		rmAddObjectDefConstraint(nugget8ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget8ID, avoidCoin);
		rmAddObjectDefConstraint(nugget8ID, avoidForest);
		rmAddObjectDefConstraint(nugget8ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget8ID, South6ward);
		rmAddObjectDefConstraint(nugget8ID, avoidFruits);
		rmAddObjectDefConstraint(nugget8ID, avoidNugget);
		rmAddObjectDefConstraint(nugget8ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget8ID, avoidNatives);
		rmAddObjectDefConstraint(nugget8ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget8ID, 0, 0.5, 0.5);
		
		int nugget9ID= rmCreateObjectDef("nugget easy 9"); 
		rmAddObjectDefItem(nugget9ID, "GiftWood", 1, 0.0);
		rmSetObjectDefMinDistance(nugget9ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget9ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget9ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget9ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget9ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget9ID, avoidSocket);
		rmAddObjectDefConstraint(nugget9ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget9ID, avoidCoin);
		rmAddObjectDefConstraint(nugget9ID, avoidForest);
		rmAddObjectDefConstraint(nugget9ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget9ID, North2ward);
		rmAddObjectDefConstraint(nugget9ID, avoidFruits);
		rmAddObjectDefConstraint(nugget9ID, avoidNugget);
		rmAddObjectDefConstraint(nugget9ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget9ID, avoidNatives);
		rmAddObjectDefConstraint(nugget9ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget9ID, 0, 0.5, 0.5);
		
		int nugget10ID= rmCreateObjectDef("nugget easy 10"); 
		rmAddObjectDefItem(nugget10ID, "GiftCoin", 1, 0.0);
		rmSetObjectDefMinDistance(nugget10ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget10ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget10ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget10ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget10ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget10ID, avoidSocket);
		rmAddObjectDefConstraint(nugget10ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget10ID, avoidCoin);
		rmAddObjectDefConstraint(nugget10ID, avoidForest);
		rmAddObjectDefConstraint(nugget10ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget10ID, East2ward);
		rmAddObjectDefConstraint(nugget10ID, avoidFruits);
		rmAddObjectDefConstraint(nugget10ID, avoidNugget);
		rmAddObjectDefConstraint(nugget10ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget10ID, avoidNatives);
		rmAddObjectDefConstraint(nugget10ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget10ID, 0, 0.5, 0.5);
		
		int nugget11ID= rmCreateObjectDef("nugget easy 11"); 
		rmAddObjectDefItem(nugget11ID, "GiftFood", 1, 0.0);
		rmSetObjectDefMinDistance(nugget11ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget11ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget11ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget11ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget11ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget11ID, avoidSocket);
		rmAddObjectDefConstraint(nugget11ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget11ID, avoidCoin);
		rmAddObjectDefConstraint(nugget11ID, avoidForest);
		rmAddObjectDefConstraint(nugget11ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget11ID, West2ward);
		rmAddObjectDefConstraint(nugget11ID, avoidFruits);
		rmAddObjectDefConstraint(nugget11ID, avoidNugget);
		rmAddObjectDefConstraint(nugget11ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget11ID, avoidNatives);
		rmAddObjectDefConstraint(nugget11ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget11ID, 0, 0.5, 0.5);
		
		int nugget12ID= rmCreateObjectDef("nugget easy 12"); 
		rmAddObjectDefItem(nugget12ID, "GiftWood", 1, 0.0);
		rmSetObjectDefMinDistance(nugget12ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget12ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget12ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget12ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget12ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget12ID, avoidSocket);
		rmAddObjectDefConstraint(nugget12ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget12ID, avoidCoin);
		rmAddObjectDefConstraint(nugget12ID, avoidForest);
		rmAddObjectDefConstraint(nugget12ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget12ID, South2ward);
		rmAddObjectDefConstraint(nugget12ID, avoidFruits);
		rmAddObjectDefConstraint(nugget12ID, avoidNugget);
		rmAddObjectDefConstraint(nugget12ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget12ID, avoidNatives);
		rmAddObjectDefConstraint(nugget12ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget12ID, 0, 0.5, 0.5);
		
		int nugget13ID= rmCreateObjectDef("nugget easy 13"); 
		rmAddObjectDefItem(nugget13ID, "GiftCoin", 1, 0.0);
		rmSetObjectDefMinDistance(nugget13ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget13ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget13ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget13ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget13ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget13ID, avoidSocket);
		rmAddObjectDefConstraint(nugget13ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget13ID, avoidCoin);
		rmAddObjectDefConstraint(nugget13ID, avoidForest);
		rmAddObjectDefConstraint(nugget13ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget13ID, North5ward);
		rmAddObjectDefConstraint(nugget13ID, avoidFruits);
		rmAddObjectDefConstraint(nugget13ID, avoidNugget);
		rmAddObjectDefConstraint(nugget13ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget13ID, avoidNatives);
		rmAddObjectDefConstraint(nugget13ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget13ID, 0, 0.5, 0.5);
		
		int nugget14ID= rmCreateObjectDef("nugget easy 14"); 
		rmAddObjectDefItem(nugget14ID, "GiftFood", 1, 0.0);
		rmSetObjectDefMinDistance(nugget14ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget14ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget14ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget14ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget14ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget14ID, avoidSocket);
		rmAddObjectDefConstraint(nugget14ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget14ID, avoidCoin);
		rmAddObjectDefConstraint(nugget14ID, avoidForest);
		rmAddObjectDefConstraint(nugget14ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget14ID, South5ward);
		rmAddObjectDefConstraint(nugget14ID, avoidFruits);
		rmAddObjectDefConstraint(nugget14ID, avoidNugget);
		rmAddObjectDefConstraint(nugget14ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget14ID, avoidNatives);
		rmAddObjectDefConstraint(nugget14ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget14ID, 0, 0.5, 0.5);
		
		int nugget15ID= rmCreateObjectDef("nugget easy 15"); 
		rmAddObjectDefItem(nugget15ID, "GiftWood", 1, 0.0);
		rmSetObjectDefMinDistance(nugget15ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget15ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget15ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget15ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget15ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget15ID, avoidSocket);
		rmAddObjectDefConstraint(nugget15ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget15ID, avoidCoin);
		rmAddObjectDefConstraint(nugget15ID, avoidForest);
		rmAddObjectDefConstraint(nugget15ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget15ID, East5ward);
		rmAddObjectDefConstraint(nugget15ID, avoidFruits);
		rmAddObjectDefConstraint(nugget15ID, avoidNugget);
		rmAddObjectDefConstraint(nugget15ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget15ID, avoidNatives);
		rmAddObjectDefConstraint(nugget15ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget15ID, 0, 0.5, 0.5);
		
		int nugget16ID= rmCreateObjectDef("nugget easy 16"); 
		rmAddObjectDefItem(nugget16ID, "GiftCoin", 1, 0.0);
		rmSetObjectDefMinDistance(nugget16ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget16ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 1);
		rmAddObjectDefToClass(nugget16ID, rmClassID("nuggets"));
		rmAddObjectDefConstraint(nugget16ID, avoidCaribou);
		rmAddObjectDefConstraint(nugget16ID, avoidImpassableLand);
		rmAddObjectDefConstraint(nugget16ID, avoidSocket);
		rmAddObjectDefConstraint(nugget16ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget16ID, avoidCoin);
		rmAddObjectDefConstraint(nugget16ID, avoidForest);
		rmAddObjectDefConstraint(nugget16ID, smallMesaConstraint);
		rmAddObjectDefConstraint(nugget16ID, West5ward);
		rmAddObjectDefConstraint(nugget16ID, avoidFruits);
		rmAddObjectDefConstraint(nugget16ID, avoidNugget);
		rmAddObjectDefConstraint(nugget16ID, nuggetAvoidNugget);
		rmAddObjectDefConstraint(nugget16ID, avoidNatives);
		rmAddObjectDefConstraint(nugget16ID, edgeConstraint);
		rmPlaceObjectDefAtLoc(nugget16ID, 0, 0.5, 0.5);
		
		
		
		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BUZZARD: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.91);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE RANDOM VULTURE TREE: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.92);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE CARIBOU: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    // CARIBOU NORTH1WARD:
	int caribouID=rmCreateObjectDef("caribou herd 1");
	rmAddObjectDefItem(caribouID, "Reindeer", rmRandInt(6,9), 8);
	rmAddObjectDefItem(caribouID, "GiftFood", 1, 0);
	rmSetObjectDefMinDistance(caribouID, 0.0);
	rmSetObjectDefMaxDistance(caribouID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(caribouID, avoidCaribou);
	rmAddObjectDefConstraint(caribouID, caribouAvoidCaribou);
	rmAddObjectDefConstraint(caribouID, avoidAll);
	rmAddObjectDefConstraint(caribouID, avoidSocket);
	rmAddObjectDefConstraint(caribouID, avoidTradeRoute); 
	rmAddObjectDefConstraint(caribouID, avoidNatives);
	rmAddObjectDefConstraint(caribouID, North1ward);
	rmAddObjectDefConstraint(caribouID, avoidImpassableLand);
	rmAddObjectDefConstraint(caribouID, canyonConstraint);
	rmAddObjectDefConstraint(caribouID, avoidForest);
	rmAddObjectDefConstraint(caribouID, smallMesaConstraint);
	rmSetObjectDefCreateHerd(caribouID, true);
	rmPlaceObjectDefAtLoc(caribouID, 0, 0.5, 0.5);
	
	// CARIBOU NORTH6WARD:
	int caribou2ID=rmCreateObjectDef("caribou herd 2");
	rmAddObjectDefItem(caribou2ID, "Reindeer", rmRandInt(6,9), 8);
	rmAddObjectDefItem(caribou2ID, "GiftFood", 1, 0);
	rmSetObjectDefMinDistance(caribou2ID, 0.0);
	rmSetObjectDefMaxDistance(caribou2ID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(caribou2ID, avoidCaribou);
	rmAddObjectDefConstraint(caribou2ID, caribouAvoidCaribou);
	rmAddObjectDefConstraint(caribou2ID, avoidAll);
	rmAddObjectDefConstraint(caribou2ID, avoidSocket);
	rmAddObjectDefConstraint(caribou2ID, avoidTradeRoute); 
	rmAddObjectDefConstraint(caribou2ID, avoidNatives);
	rmAddObjectDefConstraint(caribou2ID, North6ward);
	rmAddObjectDefConstraint(caribou2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(caribou2ID, canyonConstraint);
	rmAddObjectDefConstraint(caribou2ID, avoidForest);
	rmAddObjectDefConstraint(caribou2ID, smallMesaConstraint);
	rmSetObjectDefCreateHerd(caribou2ID, true);
	rmPlaceObjectDefAtLoc(caribou2ID, 0, 0.5, 0.5);
	
	// CARIBOU SOUTH1WARD:
	int caribou3ID=rmCreateObjectDef("caribou herd 3");
	rmAddObjectDefItem(caribou3ID, "caribou", rmRandInt(6,9), 8);
	rmAddObjectDefItem(caribou3ID, "GiftFood", 1, 0);
	rmSetObjectDefMinDistance(caribou3ID, 0.0);
	rmSetObjectDefMaxDistance(caribou3ID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(caribou3ID, avoidCaribou);
	rmAddObjectDefConstraint(caribou3ID, caribouAvoidCaribou);
	rmAddObjectDefConstraint(caribou3ID, avoidAll);
	rmAddObjectDefConstraint(caribou3ID, avoidSocket);
	rmAddObjectDefConstraint(caribou3ID, avoidTradeRoute); 
	rmAddObjectDefConstraint(caribou3ID, avoidNatives);
	rmAddObjectDefConstraint(caribou3ID, South1ward);
	rmAddObjectDefConstraint(caribou3ID, avoidImpassableLand);
	rmAddObjectDefConstraint(caribou3ID, canyonConstraint);
	rmAddObjectDefConstraint(caribou3ID, avoidForest);
	rmAddObjectDefConstraint(caribou3ID, smallMesaConstraint);
	rmSetObjectDefCreateHerd(caribou3ID, true);
	rmPlaceObjectDefAtLoc(caribou3ID, 0, 0.5, 0.5);
	
	// CARIBOU SOUTH6WARD:
	int caribou4ID=rmCreateObjectDef("caribou herd 4");
	rmAddObjectDefItem(caribou4ID, "caribou", rmRandInt(6,9), 8);
	rmAddObjectDefItem(caribou4ID, "GiftFood", 1, 0);
	rmSetObjectDefMinDistance(caribou4ID, 0.0);
	rmSetObjectDefMaxDistance(caribou4ID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(caribou4ID, avoidCaribou);
	rmAddObjectDefConstraint(caribou4ID, caribouAvoidCaribou);
	rmAddObjectDefConstraint(caribou4ID, avoidAll);
	rmAddObjectDefConstraint(caribou4ID, avoidSocket);
	rmAddObjectDefConstraint(caribou4ID, avoidTradeRoute);  
	rmAddObjectDefConstraint(caribou4ID, avoidNatives);
	rmAddObjectDefConstraint(caribou4ID, South6ward);
	rmAddObjectDefConstraint(caribou4ID, avoidImpassableLand);
	rmAddObjectDefConstraint(caribou4ID, canyonConstraint);
	rmAddObjectDefConstraint(caribou4ID, avoidForest);
	rmAddObjectDefConstraint(caribou4ID, smallMesaConstraint);
	rmSetObjectDefCreateHerd(caribou4ID, true);
	rmPlaceObjectDefAtLoc(caribou4ID, 0, 0.5, 0.5);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.93);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE COWS: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      int cowID=rmCreateObjectDef("cow 1");
      rmAddObjectDefItem(cowID, "cow", rmRandInt(3,7), 6.0);
	  rmAddObjectDefItem(cowID, "GiftFood", 1, 0.0);
      rmSetObjectDefMinDistance(cowID, 0.0);
      rmSetObjectDefMaxDistance(cowID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(cowID, avoidCow);
	  rmAddObjectDefConstraint(cowID, avoidSocket);
	  rmAddObjectDefConstraint(cowID, avoidTradeRoute);
	  rmAddObjectDefConstraint(cowID, avoidCaribou);
	  rmAddObjectDefConstraint(cowID, avoidFruits);
	  rmAddObjectDefConstraint(cowID, avoidAll);
	  rmAddObjectDefConstraint(cowID, avoidNugget);
	  rmAddObjectDefConstraint(cowID, avoidForest);
	  rmAddObjectDefConstraint(cowID, North2ward);
	  rmAddObjectDefConstraint(cowID, edgeConstraint);
	  rmAddObjectDefConstraint(cowID, smallMesaConstraint);
	  rmAddObjectDefConstraint(cowID, avoidNatives);
      rmAddObjectDefConstraint(cowID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(cowID, 0, 0.5, 0.5);
	  
	  int cow2ID=rmCreateObjectDef("cow 2");
      rmAddObjectDefItem(cow2ID, "cow", rmRandInt(3,7), 6.0);
	  rmAddObjectDefItem(cow2ID, "GiftFood", 1, 0.0);
      rmSetObjectDefMinDistance(cow2ID, 0.0);
      rmSetObjectDefMaxDistance(cow2ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(cow2ID, avoidCow);
	  rmAddObjectDefConstraint(cow2ID, avoidSocket);
	  rmAddObjectDefConstraint(cow2ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(cow2ID, avoidCaribou);
	  rmAddObjectDefConstraint(cow2ID, avoidFruits);
	  rmAddObjectDefConstraint(cow2ID, avoidAll);
	  rmAddObjectDefConstraint(cow2ID, avoidNugget);
	  rmAddObjectDefConstraint(cow2ID, avoidForest);
	  rmAddObjectDefConstraint(cow2ID, North5ward);
	  rmAddObjectDefConstraint(cow2ID, edgeConstraint);
	  rmAddObjectDefConstraint(cow2ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(cow2ID, avoidNatives);
      rmAddObjectDefConstraint(cow2ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(cow2ID, 0, 0.5, 0.5);
	  
	  int cow3ID=rmCreateObjectDef("cow 3");
      rmAddObjectDefItem(cow3ID, "cow", rmRandInt(3,7), 6.0);
	  rmAddObjectDefItem(cow3ID, "GiftFood", 1, 0.0);
      rmSetObjectDefMinDistance(cow3ID, 0.0);
      rmSetObjectDefMaxDistance(cow3ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(cow3ID, avoidCow);
	  rmAddObjectDefConstraint(cow3ID, avoidSocket);
	  rmAddObjectDefConstraint(cow3ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(cow3ID, avoidForest);
	  rmAddObjectDefConstraint(cow3ID, avoidCaribou);
	  rmAddObjectDefConstraint(cow3ID, avoidFruits);
	  rmAddObjectDefConstraint(cow3ID, avoidAll);
	  rmAddObjectDefConstraint(cow3ID, avoidNugget);
	  rmAddObjectDefConstraint(cow3ID, South2ward);
	  rmAddObjectDefConstraint(cow3ID, edgeConstraint);
	  rmAddObjectDefConstraint(cow3ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(cow3ID, avoidNatives);
      rmAddObjectDefConstraint(cow3ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(cow3ID, 0, 0.5, 0.5);
	  
	  int cow4ID=rmCreateObjectDef("cow 4");
      rmAddObjectDefItem(cow4ID, "cow", rmRandInt(3,7), 6.0);
	  rmAddObjectDefItem(cow4ID, "GiftFood", 1, 0.0);
      rmSetObjectDefMinDistance(cow4ID, 0.0);
      rmSetObjectDefMaxDistance(cow4ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(cow4ID, avoidCow);
	  rmAddObjectDefConstraint(cow4ID, avoidSocket);
	  rmAddObjectDefConstraint(cow4ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(cow4ID, avoidForest);
	  rmAddObjectDefConstraint(cow4ID, avoidCaribou);
	  rmAddObjectDefConstraint(cow4ID, avoidFruits);
	  rmAddObjectDefConstraint(cow4ID, avoidAll);
	  rmAddObjectDefConstraint(cow4ID, avoidNugget);
	  rmAddObjectDefConstraint(cow4ID, South5ward);
	  rmAddObjectDefConstraint(cow4ID, edgeConstraint);
	  rmAddObjectDefConstraint(cow4ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(cow4ID, avoidNatives);
      rmAddObjectDefConstraint(cow4ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(cow4ID, 0, 0.5, 0.5);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE SHEEPS: **************************************** //
/*================================================================================================================*/
	  int sheepID=rmCreateObjectDef("sheep 1");
      rmAddObjectDefItem(sheepID, "sheep", rmRandInt(3,7), 6.0);
	  rmAddObjectDefItem(sheepID, "GiftFood", 1, 0.0);
      rmSetObjectDefMinDistance(sheepID, 0.0);
      rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(sheepID, avoidSheep);
	  rmAddObjectDefConstraint(sheepID, avoidSocket);
	  rmAddObjectDefConstraint(sheepID, avoidTradeRoute);
	  rmAddObjectDefConstraint(sheepID, avoidCaribou);
	  rmAddObjectDefConstraint(sheepID, avoidFruits);
	  rmAddObjectDefConstraint(sheepID, avoidAll);
	  rmAddObjectDefConstraint(sheepID, avoidNugget);
	  rmAddObjectDefConstraint(sheepID, avoidForest);
	  rmAddObjectDefConstraint(sheepID, West2ward);
	  rmAddObjectDefConstraint(sheepID, edgeConstraint);
	  rmAddObjectDefConstraint(sheepID, smallMesaConstraint);
	  rmAddObjectDefConstraint(sheepID, avoidNatives);
      rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5);
	  
	  int sheep2ID=rmCreateObjectDef("sheep 2");
      rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(3,7), 6.0);
	  rmAddObjectDefItem(sheep2ID, "GiftFood", 1, 0.0);
      rmSetObjectDefMinDistance(sheep2ID, 0.0);
      rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(sheep2ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep2ID, avoidSocket);
	  rmAddObjectDefConstraint(sheep2ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(sheep2ID, avoidCaribou);
	  rmAddObjectDefConstraint(sheep2ID, avoidFruits);
	  rmAddObjectDefConstraint(sheep2ID, avoidAll);
	  rmAddObjectDefConstraint(sheep2ID, avoidNugget);
	  rmAddObjectDefConstraint(sheep2ID, avoidForest);
	  rmAddObjectDefConstraint(sheep2ID, East2ward);
	  rmAddObjectDefConstraint(sheep2ID, edgeConstraint);
	  rmAddObjectDefConstraint(sheep2ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(sheep2ID, avoidNatives);
      rmAddObjectDefConstraint(sheep2ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5);
	  
	  int sheep3ID=rmCreateObjectDef("sheep 3");
      rmAddObjectDefItem(sheep3ID, "sheep", rmRandInt(3,7), 6.0);
	  rmAddObjectDefItem(sheep3ID, "GiftFood", 1, 0.0);
      rmSetObjectDefMinDistance(sheep3ID, 0.0);
      rmSetObjectDefMaxDistance(sheep3ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(sheep3ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep3ID, avoidSocket);
	  rmAddObjectDefConstraint(sheep3ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(sheep3ID, avoidCaribou);
	  rmAddObjectDefConstraint(sheep3ID, avoidFruits);
	  rmAddObjectDefConstraint(sheep3ID, avoidAll);
	  rmAddObjectDefConstraint(sheep3ID, avoidNugget);
	  rmAddObjectDefConstraint(sheep3ID, avoidForest);
	  rmAddObjectDefConstraint(sheep3ID, West5ward);
	  rmAddObjectDefConstraint(sheep3ID, edgeConstraint);
	  rmAddObjectDefConstraint(sheep3ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(sheep3ID, avoidNatives);
      rmAddObjectDefConstraint(sheep3ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(sheep3ID, 0, 0.5, 0.5);
	  
	  int sheep4ID=rmCreateObjectDef("sheep 4");
      rmAddObjectDefItem(sheep4ID, "sheep", rmRandInt(3,7), 6.0);
	  rmAddObjectDefItem(sheep4ID, "GiftFood", 1, 0.0);
      rmSetObjectDefMinDistance(sheep4ID, 0.0);
      rmSetObjectDefMaxDistance(sheep4ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(sheep4ID, avoidSheep);
	  rmAddObjectDefConstraint(sheep4ID, avoidSocket);
	  rmAddObjectDefConstraint(sheep4ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(sheep4ID, avoidCaribou);
	  rmAddObjectDefConstraint(sheep4ID, avoidFruits);
	  rmAddObjectDefConstraint(sheep4ID, avoidAll);
	  rmAddObjectDefConstraint(sheep4ID, avoidNugget);
	  rmAddObjectDefConstraint(sheep4ID, avoidForest);
	  rmAddObjectDefConstraint(sheep4ID, East5ward);
	  rmAddObjectDefConstraint(sheep4ID, edgeConstraint);
	  rmAddObjectDefConstraint(sheep4ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(sheep4ID, avoidNatives);
      rmAddObjectDefConstraint(sheep4ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(sheep4ID, 0, 0.5, 0.5);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE RANDOM BERRIES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    // RANDOM BERRRIES:		
	int berriesID=rmCreateObjectDef("random berries 1");
	rmAddObjectDefItem(berriesID, "berrybush", rmRandInt(5,8), 6.0);
    rmAddObjectDefItem(berriesID, "GiftFood", rmRandInt(1,1), 0.0);		
	rmSetObjectDefMinDistance(berriesID, 0.0);
	rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(berriesID, avoidSocket);
	rmAddObjectDefConstraint(berriesID, avoidTradeRoute);   
	rmAddObjectDefConstraint(berriesID, West1ward);
	rmAddObjectDefConstraint(berriesID, avoidAll);
	rmAddObjectDefConstraint(berriesID, avoidNatives);
	rmAddObjectDefConstraint(berriesID, avoidForest);
	rmAddObjectDefConstraint(berriesID, edgeConstraint);
	rmAddObjectDefConstraint(berriesID, avoidFruits);
	rmAddObjectDefConstraint(berriesID, fruitsAvoidFruits);
	rmAddObjectDefConstraint(berriesID, avoidImpassableLand);
	rmAddObjectDefConstraint(berriesID, canyonConstraint);
	rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5);
	
	// RANDOM BERRRIES:		
	int berries2ID=rmCreateObjectDef("random berries 2");
	rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(5,8), 6.0); 
    rmAddObjectDefItem(berries2ID, "GiftFood", rmRandInt(1,1), 0.0);		
	rmSetObjectDefMinDistance(berries2ID, 0.0);
	rmSetObjectDefMaxDistance(berries2ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(berries2ID, avoidSocket);
	rmAddObjectDefConstraint(berries2ID, avoidTradeRoute);   
	rmAddObjectDefConstraint(berries2ID, West6ward);
	rmAddObjectDefConstraint(berries2ID, avoidAll);
	rmAddObjectDefConstraint(berries2ID, avoidNatives);
	rmAddObjectDefConstraint(berries2ID, avoidForest);
	rmAddObjectDefConstraint(berries2ID, edgeConstraint);
	rmAddObjectDefConstraint(berries2ID, avoidFruits);
	rmAddObjectDefConstraint(berries2ID, fruitsAvoidFruits);
	rmAddObjectDefConstraint(berries2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(berries2ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(berries2ID, 0, 0.5, 0.5);
	
	// RANDOM BERRRIES:		
	int berries3ID=rmCreateObjectDef("random berries 3");
	rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(5,8), 6.0);
    rmAddObjectDefItem(berries3ID, "GiftFood", rmRandInt(1,1), 0.0);		
	rmSetObjectDefMinDistance(berries3ID, 0.0);
	rmSetObjectDefMaxDistance(berries3ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(berries3ID, avoidSocket);
	rmAddObjectDefConstraint(berries3ID, avoidTradeRoute);   
	rmAddObjectDefConstraint(berries3ID, East1ward);
	rmAddObjectDefConstraint(berries3ID, avoidAll);
	rmAddObjectDefConstraint(berries3ID, avoidNatives);
	rmAddObjectDefConstraint(berries3ID, avoidForest);
	rmAddObjectDefConstraint(berries3ID, edgeConstraint);
	rmAddObjectDefConstraint(berries3ID, avoidFruits);
	rmAddObjectDefConstraint(berries3ID, fruitsAvoidFruits);
	rmAddObjectDefConstraint(berries3ID, avoidImpassableLand);
	rmAddObjectDefConstraint(berries3ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(berries3ID, 0, 0.5, 0.5);
	
	// RANDOM BERRRIES:		
	int berries4ID=rmCreateObjectDef("random berries 4");
	rmAddObjectDefItem(berries4ID, "berrybush", rmRandInt(5,8), 6.0);
    rmAddObjectDefItem(berries4ID, "GiftFood", rmRandInt(1,1), 0.0);	
	rmSetObjectDefMinDistance(berries4ID, 0.0);
	rmSetObjectDefMaxDistance(berries4ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(berries4ID, avoidSocket);
	rmAddObjectDefConstraint(berries4ID, avoidTradeRoute);   
	rmAddObjectDefConstraint(berries4ID, East6ward);
	rmAddObjectDefConstraint(berries4ID, avoidAll);
	rmAddObjectDefConstraint(berries4ID, avoidNatives);
	rmAddObjectDefConstraint(berries4ID, avoidForest);
	rmAddObjectDefConstraint(berries4ID, edgeConstraint);
	rmAddObjectDefConstraint(berries4ID, avoidFruits);
	rmAddObjectDefConstraint(berries4ID, fruitsAvoidFruits);
	rmAddObjectDefConstraint(berries4ID, avoidImpassableLand);
	rmAddObjectDefConstraint(berries4ID, canyonConstraint);
	rmPlaceObjectDefAtLoc(berries4ID, 0, 0.5, 0.5);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE RANDOM NORTHWARD TREES: ******************************** //
/*================================================================================================================*/	
	  int TreeID=rmCreateObjectDef("Tree 1");
      rmAddObjectDefItem(TreeID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(TreeID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(TreeID, 0.0);
      rmSetObjectDefMaxDistance(TreeID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(TreeID, avoidTree);
	  rmAddObjectDefConstraint(TreeID, avoidSocket);
	  rmAddObjectDefConstraint(TreeID, avoidTradeRoute);
	  rmAddObjectDefConstraint(TreeID, avoidCaribou);
	  rmAddObjectDefConstraint(TreeID, avoidFruits);
	  rmAddObjectDefConstraint(TreeID, avoidAll);
	  rmAddObjectDefConstraint(TreeID, North1ward);
	  rmAddObjectDefConstraint(TreeID, avoidNugget);
	  rmAddObjectDefConstraint(TreeID, avoidCoin);
	  rmAddObjectDefConstraint(TreeID, avoidForest);
	  rmAddObjectDefConstraint(TreeID, playerConstraint);
	  rmAddObjectDefConstraint(TreeID, edgeConstraint);
	  rmAddObjectDefConstraint(TreeID, smallMesaConstraint);
	  rmAddObjectDefConstraint(TreeID, avoidNatives);
      rmAddObjectDefConstraint(TreeID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(TreeID, 0, 0.5, 0.5, 1);
	  
	  int Tree2ID=rmCreateObjectDef("Tree 2");
      rmAddObjectDefItem(Tree2ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree2ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree2ID, 0.0);
      rmSetObjectDefMaxDistance(Tree2ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree2ID, avoidTree);
	  rmAddObjectDefConstraint(Tree2ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree2ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree2ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree2ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree2ID, avoidAll);
	  rmAddObjectDefConstraint(Tree2ID, North2ward);
	  rmAddObjectDefConstraint(Tree2ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree2ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree2ID, avoidForest);
	  rmAddObjectDefConstraint(Tree2ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree2ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree2ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree2ID, avoidNatives);
      rmAddObjectDefConstraint(Tree2ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree2ID, 0, 0.5, 0.5, 1);
	  
	  int Tree3ID=rmCreateObjectDef("Tree 3");
      rmAddObjectDefItem(Tree3ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree3ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree3ID, 0.0);
      rmSetObjectDefMaxDistance(Tree3ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree3ID, avoidTree);
	  rmAddObjectDefConstraint(Tree3ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree3ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree3ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree3ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree3ID, avoidAll);
	  rmAddObjectDefConstraint(Tree3ID, North5ward);
	  rmAddObjectDefConstraint(Tree3ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree3ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree3ID, avoidForest);
	  rmAddObjectDefConstraint(Tree3ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree3ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree3ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree3ID, avoidNatives);
      rmAddObjectDefConstraint(Tree3ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree3ID, 0, 0.5, 0.5, 1);
	  
	  int Tree4ID=rmCreateObjectDef("Tree 4");
      rmAddObjectDefItem(Tree4ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree4ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree4ID, 0.0);
      rmSetObjectDefMaxDistance(Tree4ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree4ID, avoidTree);
	  rmAddObjectDefConstraint(Tree4ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree4ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree4ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree4ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree4ID, avoidAll);
	  rmAddObjectDefConstraint(Tree4ID, North6ward);
	  rmAddObjectDefConstraint(Tree4ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree4ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree4ID, avoidForest);
	  rmAddObjectDefConstraint(Tree4ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree4ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree4ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree4ID, avoidNatives);
      rmAddObjectDefConstraint(Tree4ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree4ID, 0, 0.5, 0.5, 1);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE RANDOM SOUTHWARD TREES: ******************************** //
/*================================================================================================================*/	
	  int Tree5ID=rmCreateObjectDef("Tree 5");
      rmAddObjectDefItem(Tree5ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree5ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree5ID, 0.0);
      rmSetObjectDefMaxDistance(Tree5ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree5ID, avoidTree);
	  rmAddObjectDefConstraint(Tree5ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree5ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree5ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree5ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree5ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree5ID, avoidAll);
	  rmAddObjectDefConstraint(Tree5ID, South1ward);
	  rmAddObjectDefConstraint(Tree5ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree5ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree5ID, avoidForest);
	  rmAddObjectDefConstraint(Tree5ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree5ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree5ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree5ID, avoidNatives);
      rmAddObjectDefConstraint(Tree5ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree5ID, 0, 0.5, 0.5, 1);
	  
	  int Tree6ID=rmCreateObjectDef("Tree 6");
      rmAddObjectDefItem(Tree6ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree6ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree6ID, 0.0);
      rmSetObjectDefMaxDistance(Tree6ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree6ID, avoidTree);
	  rmAddObjectDefConstraint(Tree6ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree6ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree6ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree6ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree6ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree6ID, avoidAll);
	  rmAddObjectDefConstraint(Tree6ID, South2ward);
	  rmAddObjectDefConstraint(Tree6ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree6ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree6ID, avoidForest);
	  rmAddObjectDefConstraint(Tree6ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree6ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree6ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree6ID, avoidNatives);
      rmAddObjectDefConstraint(Tree6ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree6ID, 0, 0.5, 0.5, 1);
	  
	  int Tree7ID=rmCreateObjectDef("Tree 7");
      rmAddObjectDefItem(Tree7ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree7ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree7ID, 0.0);
      rmSetObjectDefMaxDistance(Tree7ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree7ID, avoidTree);
	  rmAddObjectDefConstraint(Tree7ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree7ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree7ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree7ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree7ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree7ID, avoidAll);
	  rmAddObjectDefConstraint(Tree7ID, South5ward);
	  rmAddObjectDefConstraint(Tree7ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree7ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree7ID, avoidForest);
	  rmAddObjectDefConstraint(Tree7ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree7ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree7ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree7ID, avoidNatives);
      rmAddObjectDefConstraint(Tree7ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree7ID, 0, 0.5, 0.5, 1);
	  
	  int Tree8ID=rmCreateObjectDef("Tree 8");
      rmAddObjectDefItem(Tree8ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree8ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree8ID, 0.0);
      rmSetObjectDefMaxDistance(Tree8ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree8ID, avoidTree);
	  rmAddObjectDefConstraint(Tree8ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree8ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree8ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree8ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree8ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree8ID, avoidAll);
	  rmAddObjectDefConstraint(Tree8ID, South6ward);
	  rmAddObjectDefConstraint(Tree8ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree8ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree8ID, avoidForest);
	  rmAddObjectDefConstraint(Tree8ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree8ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree8ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree8ID, avoidNatives);
      rmAddObjectDefConstraint(Tree8ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree8ID, 0, 0.5, 0.5, 1);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE RANDOM WESTWARD TREES: ******************************** //
/*================================================================================================================*/	
	  int Tree9ID=rmCreateObjectDef("Tree 9");
      rmAddObjectDefItem(Tree9ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree9ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree9ID, 0.0);
      rmSetObjectDefMaxDistance(Tree9ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree9ID, avoidTree);
	  rmAddObjectDefConstraint(Tree9ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree9ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree9ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree9ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree9ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree9ID, avoidAll);
	  rmAddObjectDefConstraint(Tree9ID, West1ward);
	  rmAddObjectDefConstraint(Tree9ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree9ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree9ID, avoidForest);
	  rmAddObjectDefConstraint(Tree9ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree9ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree9ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree9ID, avoidNatives);
      rmAddObjectDefConstraint(Tree9ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree9ID, 0, 0.5, 0.5, 1);
	  
	  int Tree10ID=rmCreateObjectDef("Tree 10");
      rmAddObjectDefItem(Tree10ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree10ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree10ID, 0.0);
      rmSetObjectDefMaxDistance(Tree10ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree10ID, avoidTree);
	  rmAddObjectDefConstraint(Tree10ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree10ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree10ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree10ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree10ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree10ID, avoidAll);
	  rmAddObjectDefConstraint(Tree10ID, West2ward);
	  rmAddObjectDefConstraint(Tree10ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree10ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree10ID, avoidForest);
	  rmAddObjectDefConstraint(Tree10ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree10ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree10ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree10ID, avoidNatives);
      rmAddObjectDefConstraint(Tree10ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree10ID, 0, 0.5, 0.5, 1);
	  
	  int Tree11ID=rmCreateObjectDef("Tree 11");
      rmAddObjectDefItem(Tree11ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree11ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree11ID, 0.0);
      rmSetObjectDefMaxDistance(Tree11ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree11ID, avoidTree);
	  rmAddObjectDefConstraint(Tree11ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree11ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree11ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree11ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree11ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree11ID, avoidAll);
	  rmAddObjectDefConstraint(Tree11ID, West5ward);
	  rmAddObjectDefConstraint(Tree11ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree11ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree11ID, avoidForest);
	  rmAddObjectDefConstraint(Tree11ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree11ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree11ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree11ID, avoidNatives);
      rmAddObjectDefConstraint(Tree11ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree11ID, 0, 0.5, 0.5, 1);
	  
	  int Tree12ID=rmCreateObjectDef("Tree 12");
      rmAddObjectDefItem(Tree12ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree12ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree12ID, 0.0);
      rmSetObjectDefMaxDistance(Tree12ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree12ID, avoidTree);
	  rmAddObjectDefConstraint(Tree12ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree12ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree12ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree12ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree12ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree12ID, avoidAll);
	  rmAddObjectDefConstraint(Tree12ID, West6ward);
	  rmAddObjectDefConstraint(Tree12ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree12ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree12ID, avoidForest);
	  rmAddObjectDefConstraint(Tree12ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree12ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree12ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree12ID, avoidNatives);
      rmAddObjectDefConstraint(Tree12ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree12ID, 0, 0.5, 0.5, 1);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE RANDOM EASTWARD TREES: ******************************** //
/*================================================================================================================*/	
	  int Tree13ID=rmCreateObjectDef("Tree 13");
      rmAddObjectDefItem(Tree13ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree13ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree13ID, 0.0);
      rmSetObjectDefMaxDistance(Tree13ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree13ID, avoidTree);
	  rmAddObjectDefConstraint(Tree13ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree13ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree13ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree13ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree13ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree13ID, avoidAll);
	  rmAddObjectDefConstraint(Tree13ID, East1ward);
	  rmAddObjectDefConstraint(Tree13ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree13ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree13ID, avoidForest);
	  rmAddObjectDefConstraint(Tree13ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree13ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree13ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree13ID, avoidNatives);
      rmAddObjectDefConstraint(Tree13ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree13ID, 0, 0.5, 0.5, 1);
	  
	  int Tree14ID=rmCreateObjectDef("Tree 14");
      rmAddObjectDefItem(Tree14ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree14ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree14ID, 0.0);
      rmSetObjectDefMaxDistance(Tree14ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree14ID, avoidTree);
	  rmAddObjectDefConstraint(Tree14ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree14ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree14ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree14ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree14ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree14ID, avoidAll);
	  rmAddObjectDefConstraint(Tree14ID, East2ward);
	  rmAddObjectDefConstraint(Tree14ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree14ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree14ID, avoidForest);
	  rmAddObjectDefConstraint(Tree14ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree14ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree14ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree14ID, avoidNatives);
      rmAddObjectDefConstraint(Tree14ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree14ID, 0, 0.5, 0.5, 1);
	  
	  int Tree15ID=rmCreateObjectDef("Tree 15");
      rmAddObjectDefItem(Tree15ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree15ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree15ID, 0.0);
      rmSetObjectDefMaxDistance(Tree15ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree15ID, avoidTree);
	  rmAddObjectDefConstraint(Tree15ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree15ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree15ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree15ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree15ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree15ID, avoidAll);
	  rmAddObjectDefConstraint(Tree15ID, East5ward);
	  rmAddObjectDefConstraint(Tree15ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree15ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree15ID, avoidForest);
	  rmAddObjectDefConstraint(Tree15ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree15ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree15ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree15ID, avoidNatives);
      rmAddObjectDefConstraint(Tree15ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree15ID, 0, 0.5, 0.5, 1);
	  
	  int Tree16ID=rmCreateObjectDef("Tree 16");
      rmAddObjectDefItem(Tree16ID, "TreeChristmas", rmRandInt(9,15), 12.0);
	  //rmAddObjectDefItem(Tree16ID, "GiftWood", 1, 0.0);
	  rmSetObjectDefMinDistance(Tree16ID, 0.0);
      rmSetObjectDefMaxDistance(Tree16ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(Tree16ID, avoidTree);
	  rmAddObjectDefConstraint(Tree16ID, treeAvoidTree);
	  rmAddObjectDefConstraint(Tree16ID, avoidSocket);
	  rmAddObjectDefConstraint(Tree16ID, avoidTradeRoute);
	  rmAddObjectDefConstraint(Tree16ID, avoidCaribou);
	  rmAddObjectDefConstraint(Tree16ID, avoidFruits);
	  rmAddObjectDefConstraint(Tree16ID, avoidAll);
	  rmAddObjectDefConstraint(Tree16ID, East6ward);
	  rmAddObjectDefConstraint(Tree16ID, avoidNugget);
	  rmAddObjectDefConstraint(Tree16ID, avoidCoin);
	  rmAddObjectDefConstraint(Tree16ID, avoidForest);
	  rmAddObjectDefConstraint(Tree16ID, playerConstraint);
	  rmAddObjectDefConstraint(Tree16ID, edgeConstraint);
	  rmAddObjectDefConstraint(Tree16ID, smallMesaConstraint);
	  rmAddObjectDefConstraint(Tree16ID, avoidNatives);
      rmAddObjectDefConstraint(Tree16ID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(Tree16ID, 0, 0.5, 0.5, 1);	  
/*================================================================================================================*/	  
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
	}
}  
/*================================================================================================================*/
// **************************************** THIS IS THE END OF THE MAP: ***************************************** //
/*================================================================================================================*/
	
		  
	  